﻿Imports Microsoft.VisualBasic
Imports System
Imports System.Collections
Imports System.Collections.Generic
Imports System.Configuration
Imports System.Data
Imports System.Linq
Imports System.Web
Imports System.Web.Security
Imports System.Web.UI
Imports System.Web.UI.HtmlControls
Imports System.Web.UI.WebControls
Imports System.Web.UI.WebControls.WebParts
Imports System.Xml.Linq

Public Class ModelFacade
    Public Function createClaim(ByVal dto As ClaimFormDTO) As Claim
        ' get the policy number and look for a matching policy in the database
        Dim policyNumber As Integer = dto.policyNumber
        Dim policyDAO As PolicyDAO = New PolicyDAO()
        Dim policy As Policy = policyDAO.getPolicyByNumber(policyNumber)
        If IsNothing(policy) Then
            Return Nothing
        End If
        ' if we find a match, create a Claim and link it to the policy  
        ' we must set up the relationship between Claim and Policy
        ' before attempting to generate the reference, because the 
        ' ReferenceGenerator uses properties from both classes 
        Dim claim As Claim = New Claim()
        ' link the two objects
        claim.Policy = policy
        claim.PolicyID = policy.PolicyID
        claim.Amount = dto.ClaimAmount
        claim.Description = dto.ClaimDescription
        claim.DateOfClaim = DateTime.Now
        claim.IsApproved = False
        Dim generator As ReferenceGenerator = New ReferenceGenerator()
        Dim reference As String = generator.getReference(claim)
        claim.Reference = reference
        ' write the claim to the database
        Dim claimDAO As ClaimDAO = New ClaimDAO()
        claimDAO.saveClaim(claim)
        ' return the claim, associated with the policy
        Return claim
    End Function

    Public Function getClaims(ByVal whereClause As String) As List(Of Claim)
        Dim myDAO As ClaimDAO = getClaimDAO()
        Dim claimCollection As List(Of Claim) = myDAO.getClaimList(whereClause)
        Return claimCollection
    End Function
    Public Function getClaims() As List(Of Claim)
        Dim myDAO As ClaimDAO = getClaimDAO()
        Dim claimCollection As List(Of Claim) = myDAO.getClaimList()
        Return claimCollection
    End Function

    Public Function getClaimByRef(ByVal reference As String) As Claim
        Dim myDAO As ClaimDAO = getClaimDAO()
        Return myDAO.getClaimByRef(reference)
    End Function
    Public Sub updateClaim(ByVal claim As Claim)
        Dim myDAO As ClaimDAO = getClaimDAO()
        myDAO.updateClaim(claim)
    End Sub

    Public Function getPolicy(ByVal policyNumber As Integer) As Policy
        Dim myDAO As PolicyDAO = getPolicyDAO()
        Dim myDTO As Policy = myDAO.getPolicyByNumber(policyNumber)
        Return myDTO
    End Function

    Private Function getClaimDAO() As ClaimDAO
        Dim myDAO As ClaimDAO = New ClaimDAO()
        Return myDAO
    End Function
    Private Function getPolicyDAO() As PolicyDAO
        Dim myDAO As PolicyDAO = New PolicyDAO()
        Return myDAO
    End Function

End Class

