CREATE PROCEDURE ResetDB
/*
Recreate all tables
Use only for testing purposes
*/
AS

DROP TABLE claim
CREATE TABLE claim (
  claimID INT PRIMARY KEY IDENTITY(1,1) NOT NULL,
  reference VARCHAR(20),
  description VARCHAR(100),
  amount MONEY,
  approved CHAR(1),
  claimDate DATETIME,
  policyID INT
)

DROP TABLE policy
CREATE TABLE policy (
  policyID INT PRIMARY KEY IDENTITY(1,1) NOT NULL,
  policyNumber INT,
  type VARCHAR(20),
  startDate DATETIME,
  annualPremium MONEY,
  paidUp CHAR(1),
  policyHolderID INT,
)

DROP TABLE policyholder
CREATE TABLE policyholder (
  policyholderID INT PRIMARY KEY IDENTITY(1,1) NOT NULL,
  accountNumber INT,
  name VARCHAR(30),
  address VARCHAR(50)
)

ALTER TABLE claim
ADD CONSTRAINT claimFK
FOREIGN KEY (policyID)
REFERENCES policy(policyID)
ALTER TABLE policy
ADD CONSTRAINT policyFK
FOREIGN KEY (policyHolderID)
REFERENCES policyHolder(policyHolderID)
RETURN